Index: dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/context_dynamico.xml
===================================================================
--- dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/context_dynamico.xml	(revision 4232)
+++ dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/context_dynamico.xml	(revision 4239)
@@ -11,4 +11,5 @@
   <!-- Definition of all existing variables in field_def_dynamico.xml                                              -->
   <!-- =========================================================================================================== -->
+  <field_definition src="./field_def_physics.xml" />
   <field_definition src="./field_def_dynamico.xml" />
 
@@ -16,4 +17,5 @@
   <!-- Definition of output files in file_def_dynamico.xml, not including restart files                            -->
   <!-- =========================================================================================================== -->
+  <file_definition src="./file_def_physics.xml" />  
   <file_definition src="./file_def_dynamico.xml" />  
 
Index: dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/field_def_dynamico.xml
===================================================================
--- dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/field_def_dynamico.xml	(revision 4232)
+++ dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/field_def_dynamico.xml	(revision 4239)
@@ -7,4 +7,6 @@
   
   <field_group id="standard_output"> 
+
+    <field_group group_ref="phyparam_output"/>
     
     <field id="timestep" grid_ref="scalar" unit="s"/>
Index: dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/field_def_physics.xml
===================================================================
--- dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/field_def_physics.xml	(revision 4239)
+++ dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/field_def_physics.xml	(revision 4239)
@@ -0,0 +1,51 @@
+<!-- =========================================================================================================== -->
+<!-- field_def_phyparam.xml                                                                                      -->
+<!-- Definition of all existing variables that can be output from phyparam                                       -->
+<!-- =========================================================================================================== -->
+
+<field_definition level="1" enabled=".TRUE." operation="instant">
+  
+  <field_group id="phyparam_output">     
+    <field_group domain_ref="i">
+      <field id="phyparam_mu0" />
+      <field id="phyparam_alb" />
+      <field id="phyparam_ts" />
+      <field id="phyparam_ps" />
+      <field id="phyparam_slp" />
+      <field id="phyparam_swsurf" />
+      <field id="phyparam_lwsurf" />
+
+      <field id="phyparam_coslon" />
+      <field id="phyparam_sinlon" />
+      <field id="phyparam_coslat" />
+      <field id="phyparam_sinlat" />
+    </field_group>
+  </field_group>
+  
+</field_definition>
+
+<!--       
+       call writefield('u','Vent zonal moy','m/s',pu)
+       call writefield('v','Vent meridien moy','m/s',pv)
+       call writefield('temp','Temperature','K',pt)
+       call writefield('geop','Geopotential','m2/s2',pphi)
+       call writefield('plev','plev','Pa',pplev(:,1:nlayer))
+
+       call writefield('du','du',' ',pdu)
+       call writefield('dv','du',' ',pdv)
+       call writefield('dt','du',' ',pdt)
+       call writefield('dtsw','dtsw',' ',zdtsw)
+       call writefield('dtlw','dtlw',' ',zdtlw)
+
+       call writefield('ts','Surface temper','K',tsurf)
+       call writefield('coslon','coslon',' ',coslon)
+       call writefield('sinlon','sinlon',' ',sinlon)
+       call writefield('coslat','coslat',' ',coslat)
+       call writefield('sinlat','sinlat',' ',sinlat)
+       call writefield('mu0','mu0',' ',mu0)
+       call writefield('alb','alb',' ',albedo)
+       call writefield('ps','Surface pressure','Pa',pplev(:,1))
+       call writefield('slp','Sea level pressure','Pa',zpmer)
+       call writefield('swsurf','SW surf','Pa',zfluxsw)
+       call writefield('lwsurf','LW surf','Pa',zfluxlw)
+-->
Index: dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/file_def_dynamico.xml
===================================================================
--- dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/file_def_dynamico.xml	(revision 4232)
+++ dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/file_def_dynamico.xml	(revision 4239)
@@ -5,5 +5,5 @@
 <file_definition > 
 
-  <file id="output_dcmip2016_native" convention="CF" enabled="false" output_freq="3h" sync_freq="3h" output_level="10" timeseries="none" description="Dry baroclinic wave" > 
+  <file id="dynamico_native" convention="CF" enabled="false" output_freq="3h" sync_freq="3h" output_level="10" timeseries="none" description="Simple physics" > 
     
     <field_group id="dcmip2016_output_field_once" operation="once" freq_offset="0ts" ts_enabled="true">
@@ -20,49 +20,36 @@
       <field field_ref="ps" name="PS"       standard_name="surface_pressure" long_name="Surface pressure"         unit="Pa" />
       <field field_ref="phis" operation="once" freq_offset="0ts" name="PHIS"   standard_name="surface_geopotential" long_name="Surface geopotential" unit="m2/m2"/>
+
+<!--      
       <field field_ref="geopot"  name="PHI"   standard_name="geopotential" long_name="geopotential" unit="m2/s2"/>
-      <field field_ref="ulon" name="U"      standard_name="eastward_wind" long_name="Zonal wind"                  unit="m/s"/>
-      <field field_ref="ulat" name="V"      standard_name="northward_wind" long_name="Meridional wind"            unit="m/s"/>
       <field field_ref="uz" name="W"        standard_name="upward_air_velocity" long_name="Vertical velocity"     unit="m/s"/>
       <field field_ref="omega" name="OMEGA"        standard_name="lagrangian_tendency_of_air_pressure" long_name="Vertical pressure velocity"     unit="Pa/s"/>
       <field field_ref="p"  name="P"        standard_name="air_pressure" long_name="Pressure"     unit="Pa"/>
+      <field field_ref="w850" name="W850"       long_name="Vertical velocity at 850 hPa"     unit="m/s"/>
+      <field field_ref="w500" name="W500"       long_name="Vertical velocity at 500 hPa"     unit="m/s"/>
+-->
+      <field field_ref="ulon" name="U"      standard_name="eastward_wind" long_name="Zonal wind"                  unit="m/s"/>
+      <field field_ref="ulat" name="V"      standard_name="northward_wind" long_name="Meridional wind"            unit="m/s"/>
       <field field_ref="temp"  name="T"        standard_name="air_temperature" long_name="Temperature"     unit="K"/>
-<!--
-      <field field_ref="q1"  name="Q"        standard_name="specific_humidity"  long_name="Specific humidity"          unit="kg/kg"/>
-      <field field_ref="q2"  name="Qc"                                          long_name="Cloud water mixing ration"  unit="kg/kg"/>
-      <field field_ref="q3"  name="Qr"                                          long_name="Rain water mixing ration"  unit="kg/kg"/>
--->
-      <field field_ref="precl"  name="PRECT"     standard_name="rainfall_rate"  long_name="Large Scale precipitation rate"  unit="m/s"/>
-<!--
-      <field field_ref="q4"  name="Q1"      long_name="Single chlorine mixing ratio"  unit="kg/kg"/> 
-      <field field_ref="q5"  name="Q2"      long_name="Chlorine gas mixing ratio"  unit="kg/kg"/> 
--->
-      <field field_ref="Q1_col_int"  name="Q1_col_int"      long_name="Single chlorine column integrated mixing ratio"  unit="kg/m2"/> 
-      <field field_ref="Q2_col_int"  name="Q2_col_int"      long_name="Chlorine gas column integrated mixing ratio"  unit="kg/m2"/> 
+
       <field field_ref="u850" name="U850"       long_name="Zonal wind at 850 hPa"      unit="m/s"/>
       <field field_ref="v850" name="V850"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
-      <field field_ref="w850" name="W850"       long_name="Vertical velocity at 850 hPa"     unit="m/s"/>
       <field field_ref="t850" name="T850"       long_name="Temperature at 850 hPa"   unit="K"/>
       <field field_ref="omega850" name="OMEGA850"   long_name="Vertical pressure velocity at 850 hPa"     unit="Pa/s"/>
       <field field_ref="u500" name="U500"       long_name="Zonal wind at 500 hPa"      unit="m/s"/>
       <field field_ref="v500" name="V500"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
-      <field field_ref="w850" name="W500"       long_name="Vertical velocity at 500 hPa"     unit="m/s"/>
       <field field_ref="t500" name="T500"       long_name="Temperature at 850 hPa"   unit="K"/>
       <field field_ref="omega500" name="OMEGA500"   long_name="Vertical pressure velocity at 500 hPa"     unit="Pa/s"/>
-      <field field_ref="SST" name="SST"       long_name="Sea surface temperature"   unit="K"/>
       
     </field_group>
 
     <variable name="model" type="string" > dynamico </variable>
-    <variable name="test_case" type="string" > 161_dry </variable>
-    <variable name="horizontal_resolution" type="string" > 1 degree native (grid points : 80x80x10) </variable>
-    <variable name="levels" type="string" > L30 </variable>
     <variable name="grid" type="string" > hex </variable>
     <variable name="equation" type="string" > hydro </variable>
-    <variable name="time_frequency" type="string" > 3hr </variable>    
 
   </file>
 
 
-  <file id="output_dcmip2016_regular" enabled="true" output_freq="3h" sync_freq="3h" output_level="10" description="Dry baroclinic wave" timeseries="none" > 
+  <file id="dynamico_regular" enabled="true" output_freq="24h" sync_freq="24h" output_level="10" description="Simple physics" timeseries="none" >
     
     <field_group group_ref="dcmip2016_output_field_once"/>
@@ -71,13 +58,8 @@
 
     <variable name="model" type="string" > dynamico </variable>
-    <variable name="test_case" type="string" > 161_dry </variable>
-    <variable name="horizontal_resolution" type="string" > 1 degree interpolated (grid points : 80x80x10) </variable>
-    <variable name="levels" type="string" > L30 </variable>
     <variable name="grid" type="string" > hex </variable>
     <variable name="equation" type="string" > hydro </variable>
-    <variable name="time_frequency" type="string" > 3hr </variable>    
 
   </file>
 
-
 </file_definition>
Index: dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/file_def_physics.xml
===================================================================
--- dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/file_def_physics.xml	(revision 4239)
+++ dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/file_def_physics.xml	(revision 4239)
@@ -0,0 +1,28 @@
+<file_definition > 
+
+  <file id="physics_native" convention="CF" enabled="false" output_freq="3h" sync_freq="3h" output_level="10" timeseries="none" description="Simple physics" > 
+    
+    <field_group id="phyparam_output_field" ts_enabled="true">
+      <field field_ref="phyparam_ts" unit="K"/>
+      <field field_ref="phyparam_swsurf" unit="W/m2"/>
+      <field field_ref="phyparam_lwsurf" unit="W/m2"/>
+    </field_group>
+
+    <variable name="model" type="string" > dynamico </variable>
+    <variable name="grid" type="string" > hex </variable>
+    <variable name="equation" type="string" > hydro </variable>
+
+  </file>
+
+
+  <file id="physics_regular" enabled="true" output_freq="6h" sync_freq="6h" output_level="10" description="Simple physics" timeseries="none" >
+    
+    <field_group group_ref="phyparam_output_field"  domain_ref="regular_one_degree" />
+
+    <variable name="model" type="string" > dynamico </variable>
+    <variable name="grid" type="string" > hex </variable>
+    <variable name="equation" type="string" > hydro </variable>
+
+  </file>
+
+</file_definition>
Index: dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/iodef.xml
===================================================================
--- dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/iodef.xml	(revision 4232)
+++ dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/iodef.xml	(revision 4239)
@@ -12,5 +12,5 @@
 
         	<variable_group id="parameters" >
-        	   <variable id="info_level" type="int">100</variable>
+        	   <variable id="info_level" type="int">1</variable>
                    <variable id="using_server" type="bool">false</variable>
          	</variable_group>
Index: dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/job_CICLAD.sh
===================================================================
--- dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/job_CICLAD.sh	(revision 4232)
+++ dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/job_CICLAD.sh	(revision 4239)
@@ -3,6 +3,6 @@
 #PBS -q std
 #PBS -n
-#PBS -l nodes=1:ppn=40
-#PBS -l walltime=00:15:00
+#PBS -l nodes=1:ppn=60
+#PBS -l walltime=01:00:00
 #PBS -l mem=120gb
 #PBS -l vmem=120gb
@@ -42,6 +42,9 @@
 module load hdf5/1.8.18-parallel-ifort
 module load netcdf4/4.4.1.1-parallel-ifort
+module list
 
 rm -rf gcm.log logs *.nc netcdf
+ls -lrth
+which mpirun
 mpirun -np 40 -cpus-per-proc $OMP_NUM_THREADS -bycore -bind-to-core -report-bindings ./gcm.exe > gcm.log 2>&1
 date >> gcm.log
Index: dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/run.def
===================================================================
--- dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/run.def	(revision 4232)
+++ dynamico_lmdz/simple_physics/config/DYNAMICO/TEST/run.def	(revision 4239)
@@ -10,11 +10,12 @@
 
 #-------------- Mesh ----------------
-nbp=21
+nbp=41
 optim_it=500
 nsplit_i=2
-nsplit_j=2
+nsplit_j=3
 llm=30
 omp_level_size=1
-disvert=ncarl30
+#disvert=ncarl30
+disvert=std
 
 #------------ Numerics --------------
@@ -34,7 +35,11 @@
 itau_physics=1
 physics=plugin
+# 0.25 day = 6h
+period_sort=0.25
+diurnal=.TRUE.
 
 #---------------- Run ---------------
 run_length=2592000
+# 21600s = 6h
 write_period=21600
 
@@ -42,6 +47,7 @@
 #write_period=480
 
-etat0=dcmip4
-dcmip4_testcase=1
+#etat0=dcmip4
+#dcmip4_testcase=1
+etat0=isothermal
 
 #------------ Diagnostics -----------